"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var createReduxStore_1 = require("../utils/createReduxStore");
var meta_1 = require("../utils/meta");
var MetaReducer = /** @class */ (function () {
    function MetaReducer() {
    }
    MetaReducer.record = function (name) {
        if (MetaReducer.stash[name]) {
            createReduxStore_1.getStore().getState()[MetaReducer.reducerName][name] = MetaReducer.stash[name];
            delete MetaReducer.stash[name];
        }
        MetaReducer.usedMetaNames.add(name);
    };
    MetaReducer.addCase = function (name, types) {
        MetaReducer.metaPrepare[types.prepare] = name;
        MetaReducer.metaSuccess[types.success] = name;
        MetaReducer.metaFail[types.fail] = name;
    };
    MetaReducer.getData = function (name) {
        return createReduxStore_1.getStore().getState()[MetaReducer.reducerName][name];
    };
    MetaReducer.createData = function () {
        var _a;
        if (MetaReducer.isAppend) {
            return {};
        }
        MetaReducer.isAppend = true;
        return _a = {},
            _a[MetaReducer.reducerName] = function (state, action) {
                if (state === undefined) {
                    state = {};
                }
                var name;
                name = MetaReducer.metaPrepare[action.type];
                if (name) {
                    return MetaReducer.modifyReducer(state, name, action, true);
                }
                name = MetaReducer.metaSuccess[action.type];
                if (name) {
                    return MetaReducer.modifyReducer(state, name, action, false);
                }
                name = MetaReducer.metaFail[action.type];
                if (name) {
                    return MetaReducer.modifyReducer(state, name, action, false);
                }
                return state;
            },
            _a;
    };
    MetaReducer.modifyReducer = function (state, name, action, isLoading) {
        var _a, _b, _c;
        switch (action.metaKey) {
            case true:
                var meta = {
                    actionType: action.type,
                    loading: isLoading,
                    message: action.message,
                    httpStatus: action.httpStatus,
                    businessCode: action.businessCode,
                };
                if (!MetaReducer.usedMetaNames.has(name)) {
                    MetaReducer.stash[name] = meta;
                    return state;
                }
                return tslib_1.__assign(tslib_1.__assign({}, state), (_a = {}, _a[name] = meta, _a));
            case false:
                return state;
            default:
                var metas = tslib_1.__assign(tslib_1.__assign(tslib_1.__assign({}, state[name]), (_b = {}, _b[action.metaKey] = {
                    actionType: action.type,
                    loading: isLoading,
                    message: action.message,
                    httpStatus: action.httpStatus,
                    businessCode: action.businessCode,
                }, _b)), meta_1.METAS_PICK_METHOD);
                if (!MetaReducer.usedMetaNames.has(name)) {
                    MetaReducer.stash[name] = metas;
                    return state;
                }
                return tslib_1.__assign(tslib_1.__assign({}, state), (_c = {}, _c[name] = metas, _c));
        }
    };
    MetaReducer.reducerName = '__metas__';
    MetaReducer.isAppend = false;
    MetaReducer.metaPrepare = {};
    MetaReducer.metaSuccess = {};
    MetaReducer.metaFail = {};
    MetaReducer.usedMetaNames = new Set();
    MetaReducer.stash = {};
    return MetaReducer;
}());
exports.MetaReducer = MetaReducer;
// Register metas automatically
createReduxStore_1.appendReducers(MetaReducer.createData());
