"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var method_1 = require("../utils/method");
var OrphanHttpServiceHandle = /** @class */ (function () {
    function OrphanHttpServiceHandle(config, method, fetchApi) {
        this.method = method_1.METHOD.get;
        this.config = config;
        this.fetchApi = fetchApi;
        this.method = method;
    }
    OrphanHttpServiceHandle.prototype.collect = function () {
        var config = this.config;
        var action = {
            body: config.body || {},
            query: config.query || {},
            successText: '',
            failText: '',
            hideError: true,
            requestOptions: config.requestOptions || {},
            uri: config.uri,
            type: {
                prepare: '',
                success: '',
                fail: '',
            },
            method: this.method,
            useCache: typeof config.useCache === 'boolean'
                ? config.useCache
                : config.cacheMillSeconds !== undefined && config.cacheMillSeconds > 0,
            cacheMillSeconds: config.cacheMillSeconds || 0,
            cacheKey: '',
            metaKey: false,
            payload: {},
            onPrepare: null,
            onSuccess: null,
            onFail: null,
            reducerName: '',
        };
        return action;
    };
    return OrphanHttpServiceHandle;
}());
exports.OrphanHttpServiceHandle = OrphanHttpServiceHandle;
