"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dev_1 = require("../../libs/dev");
var instanceName = '';
var actionCounter = 0;
// In case the same classname is compressed even when it's dev environment
// The program can be look as compressed if the length of classname is less than 2 characters.
var CLASS_COUNTER = {};
function ReduxModel() { }
var isCompressed = function (className) {
    if (typeof ReduxModel.name === 'string') {
        return ReduxModel.name !== 'ReduxModel';
    }
    else {
        return className.length === 1;
    }
};
exports.setInstanceName = function (className, alias) {
    instanceName = className + (alias ? "." + alias : '');
    actionCounter = 0;
    var dictKey = "dict_" + instanceName;
    if (CLASS_COUNTER[dictKey] === undefined) {
        CLASS_COUNTER[dictKey] = 0;
    }
    else if (!dev_1.isDebug() || isCompressed(className)) {
        CLASS_COUNTER[dictKey] += 1;
    }
    if (CLASS_COUNTER[dictKey] > 0) {
        instanceName += "-" + CLASS_COUNTER[dictKey];
    }
    return instanceName;
};
exports.getInstanceName = function () {
    return instanceName;
};
exports.increaseActionCounter = function () {
    actionCounter += 1;
    return actionCounter;
};
